---
title: Create Digital Wallet App
description: The POST {{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications operation creates a digital wallet app in the specified environment.
component: pingone-api
page_id: pingone-api:credentials:digital-wallet-apps/create-digital-wallet-app
canonical_url: https://developer.pingidentity.com/pingone-api/credentials/digital-wallet-apps/create-digital-wallet-app.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Digital Wallet App

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications
```

The `POST {{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications` operation creates a digital wallet app in the specified environment.

A request body is required to create a digital wallet app.

### Prerequisites

[Create Application (OIDC Mobile App)](../../platform/applications/applications-1/create-application-oidc-mobile-app.html) to get an `application.id` for the body. Refer also to [Application Management](../../platform/applications/application-management.html), especially [Application Operations](../../platform/applications/applications-1.html).

> **Collapse: Request Model**
>
> Refer to [Digital wallet app data model](../digital-wallet-apps.html#digital-wallet-app-data-model) for full property descriptions.
>
> | Property               | Type    | Required? |
> | ---------------------- | ------- | --------- |
> | `application.id`       | String  | Required  |
> | `appOpenUrl`           | String  | Required  |
> | `name`                 | String  | Required  |
> | `usesPingOneWalletSDK` | Boolean | Optional  |

The PingOne application identified by `application.id` must be a native application (`type` set to `NATIVE_APP`) and have either a mobile bundle ID (`mobile.bundleId`) or a package name (`mobile.packageName`).

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "name": "Customer Wallet App",
    "application": {
        "id": "{{appID}}"
    },
    "appOpenUrl": "{{appOpenUrl}}"
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "name": "Customer Wallet App",
    "application": {
        "id": "{{appID}}"
    },
    "appOpenUrl": "{{appOpenUrl}}"
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""name"": ""Customer Wallet App""," + "\n" +
@"    ""application"": {" + "\n" +
@"        ""id"": ""{{appID}}""" + "\n" +
@"    }," + "\n" +
@"    ""appOpenUrl"": ""{{appOpenUrl}}""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications"
  method := "POST"

  payload := strings.NewReader(`{
    "name": "Customer Wallet App",
    "application": {
        "id": "{{appID}}"
    },
    "appOpenUrl": "{{appOpenUrl}}"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/digitalWalletApplications HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "name": "Customer Wallet App",
    "application": {
        "id": "{{appID}}"
    },
    "appOpenUrl": "{{appOpenUrl}}"
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"name\": \"Customer Wallet App\",\n    \"application\": {\n        \"id\": \"{{appID}}\"\n    },\n    \"appOpenUrl\": \"{{appOpenUrl}}\"\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "name": "Customer Wallet App",
    "application": {
      "id": "{{appID}}"
    },
    "appOpenUrl": "{{appOpenUrl}}"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "name": "Customer Wallet App",
    "application": {
      "id": "{{appID}}"
    },
    "appOpenUrl": "{{appOpenUrl}}"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications"

payload = json.dumps({
  "name": "Customer Wallet App",
  "application": {
    "id": "{{appID}}"
  },
  "appOpenUrl": "{{appOpenUrl}}"
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "name": "Customer Wallet App",\n    "application": {\n        "id": "{{appID}}"\n    },\n    "appOpenUrl": "{{appOpenUrl}}"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "name": "Customer Wallet App",
  "application": {
    "id": "{{appID}}"
  },
  "appOpenUrl": "{{appOpenUrl}}"
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"name\": \"Customer Wallet App\",\n    \"application\": {\n        \"id\": \"{{appID}}\"\n    },\n    \"appOpenUrl\": \"{{appOpenUrl}}\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/digitalWalletApplications")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/digitalWalletApplications/9f698462-21d5-4fd6-8599-c2b56683eb57"
        }
    },
    "id": "9f698462-21d5-4fd6-8599-c2b56683eb57",
    "createdAt": "2023-02-09T19:43:00.817Z",
    "updatedAt": "2023-02-09T19:43:00.817Z",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "name": "Customer Wallet App",
    "application": {
        "id": "84cb89a4-fc4f-4422-b4ae-56b0109a9dbb"
    },
    "appOpenUrl": "https://credentials.customer.com",
    "usesPingOneWalletSDK": true
}
```
